
/**
* MACS is an Anticipatory Learning Classifier System written in Java.
* 
* Copyright (C) Pierre Grard and Olivier Sigaud with the occasional help
* of Fabien Flacher.
* Contact Olivier.Sigaud@lip6.fr for any queries, or write to
* 
* Olivier Sigaud
* AnimatLab
* Laboratoire d'Informatique de Paris 6
* 8, rue du Capitaine Scott,
* 75015 PARIS, FRANCE
* 
* This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
* 
* More informations about the GNU General Public License can be found
* at the following web site:
* http://www.opensource.org/licenses/gpl-license.php
**/

package MACS;

import java.util.*;
import Classifier.Perception;
/**
 * This class stores informations about which states are final in the problem.
* @author <a href="mailto:Olivier.Sigaud@lip6.fr"> Olivier Sigaud</a> and <a href="mailto:gerpy@free.fr"> Pierre Grard</a>.
* 
 */
final class FinalStateModel extends TreeMap 
{
   
   /**
    * @param p
    * @param b
    */
   public void put(Perception p, boolean b) 
   {
	//check that true means that the value is forced
	Boolean retour = (Boolean)put(p,new Boolean(b));
	if (retour!=null)
	if (retour.booleanValue() != b) System.out.println("FinalStateModel : warning, value forced");    
   }
   
   /**
    * @param p
    * @return boolean
    */
   public boolean get(Perception p) 
   {
	return ((Boolean)super.get(p)).booleanValue();    
   }
   
   /**
    * @return String
    */
   public final String toString() 
   {
	String str = new String();

	Iterator it = keySet().iterator();
	while (it.hasNext())
	    {
		Perception p = (Perception)it.next();
		str = str + p.toString() + " => " + get(p) + "\n";
	    }

	return str;    
   }
}
