
/**
* MACS is an Anticipatory Learning Classifier System written in Java.
* 
* Copyright (C) Pierre Grard and Olivier Sigaud with the occasional help
* of Fabien Flacher.
* Contact Olivier.Sigaud@lip6.fr for any queries, or write to
* 
* Olivier Sigaud
* AnimatLab
* Laboratoire d'Informatique de Paris 6
* 8, rue du Capitaine Scott,
* 75015 PARIS, FRANCE
* 
* This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
* 
* More informations about the GNU General Public License can be found
* at the following web site:
* http://www.opensource.org/licenses/gpl-license.php
**/

package Utils;

import java.io.*;
import java.util.*;

/**
 * Class that defines a chronometer
 * <P>
 * @author <a href="mailto:Olivier.Sigaud@lip6.fr"> Olivier Sigaud</a> and <a href="mailto:gerpy@free.fr"> Pierre Grard</a>.
 */

public final class Chrono
{
    protected    Date D1;
    protected    Date D2;
    static Chrono universel;

    public  Chrono()
    {
	D1           = new Date();
    }

    public void stop()
    {
	D2           = new Date();
	printTime(D2.getTime()-D1.getTime());
    }


    public void stopInMinutes()
    {
	D2           = new Date();
	printTimeInMinutes(D2.getTime()-D1.getTime());
    }


    public void stopInSeconds()
    {
	D2           = new Date();
	printTimeInSeconds(D2.getTime()-D1.getTime());
    }

    public void printTime(long delay)
    {
	System.out.print("Temps d'excution :");
	if (delay<1000) System.out.println(delay+" ms");
	else
	    {
		long d1	=	delay/1000;
		long ms	= 	(delay-d1*1000);
		if (d1<60) System.out.println(d1+" s " + ms+" ms");
		else
		    {
			long d2	=	d1/60;
			long reste	=	d1-d2*60;
			if (d2<60) System.out.println(d2+" min "+ reste + " s");
			else
			    {
				long d3	=	d2/60;
				long r2	=	d2-d3*60;
				System.out.println(d3+ " h " + r2+" min "+ reste + " s");
			    }
		    }
	    }
    }

    public void printTimeInMinutes(long delay)
    {
	System.out.print("Temps d'excution :");
	double d1	=	delay/60000;
	System.out.println(d1+" min ");
    }

    public void printTimeInSeconds(long delay)
    {
	System.out.print("Temps d'excution :");
	double d1	=	delay/1000;
	System.out.println(d1+" s ");
    }
    
    public static void sStart()
    {
	universel = new Chrono();
    }

    public static void sStop()
    {
	universel.stop();
    }

    public static void main(String[] args)
    {
    }
}		
