
/**
* MACS is an Anticipatory Learning Classifier System written in Java.
* 
* Copyright (C) Pierre Grard and Olivier Sigaud with the occasional help
* of Fabien Flacher.
* Contact Olivier.Sigaud@lip6.fr for any queries, or write to
* 
* Olivier Sigaud
* AnimatLab
* Laboratoire d'Informatique de Paris 6
* 8, rue du Capitaine Scott,
* 75015 PARIS, FRANCE
* 
* This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
* 
* More informations about the GNU General Public License can be found
* at the following web site:
* http://www.opensource.org/licenses/gpl-license.php
**/

package Utils;

import java.util.StringTokenizer;

/**
 * The name tells what that class is...
 * @author <a href="mailto:Olivier.Sigaud@lip6.fr"> Olivier Sigaud</a> and <a href="mailto:gerpy@free.fr"> Pierre Grard</a>.
 */	
public final class Misc
{	
    public static final String putSideBySide (String str1, String str2, short offset)
    {
	String str = new String();
	str1 = str1.trim(); str2 = str2.trim();
	StringTokenizer strTok1 = new StringTokenizer(str1, "\n");
	StringTokenizer strTok2 = new StringTokenizer(str2, "\n");

	while (strTok1.hasMoreTokens() || strTok2.hasMoreTokens())
	    {
		String tok1 = "";
		String tok2 = "";
		if (strTok1.hasMoreTokens()) tok1=strTok1.nextToken();
		if (strTok2.hasMoreTokens()) tok2=strTok2.nextToken();

		str = str
		    + tok1 + buildStringWithSpaces((short)(offset-tok1.length()))
		    + tok2 + buildStringWithSpaces((short)(offset-tok2.length()))
		    + "\n";
	    }

	return str;
    }

    private static final String buildStringWithSpaces(short length)
    {
	String str = new String();

	for (short i=0 ; i<length ; i++)
		str = str + " ";

	return str;
    }

    public static final String removeSpaces(String string)
    {
	String strTemp = new	String();

	for (short i=0; i<string.length(); i++)
	    if ((string.charAt(i)!=' ') && ((string.charAt(i)!='\t')) )
		strTemp = strTemp + string.charAt(i);

	return (strTemp);
    }

    public static final String strReplace(String str, String str1, String str2)
    {
	int index = str.indexOf(str1);
	if (index==-1)
	    return str;
	else
	    {
		String strResult = str.substring(0, index) + str2 + str.substring(index+str1.length());
		return strReplace (strResult, str1, str2);
	    }
    }

    //  y
    //  |            ___________     1
    //  |           /
    //  |          / |        
    //  |        f/  |
    //  |        /   |
    //  |_______/____|____________ x 0
    //          ^    ^
    //      FACTOR_0 FACTOR_1 
    public static final double boundedLinearFunction(int x, double factor0, double factor1)
    {
	if (x<factor0)		return 0.0;
	else if (x>factor1)	return 1.0;
	else			return ((1.0/(factor1-factor0))*(x-factor0));
    }
}
