
/**
* MACS is an Anticipatory Learning Classifier System written in Java.
* 
* Copyright (C) Pierre Grard and Olivier Sigaud with the occasional help
* of Fabien Flacher.
* Contact Olivier.Sigaud@lip6.fr for any queries, or write to
* 
* Olivier Sigaud
* AnimatLab
* Laboratoire d'Informatique de Paris 6
* 8, rue du Capitaine Scott,
* 75015 PARIS, FRANCE
* 
* This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
* 
* More informations about the GNU General Public License can be found
* at the following web site:
* http://www.opensource.org/licenses/gpl-license.php
**/

package Utils;

import java.util.Random;

/**
 * Class that defines a random number generator.
 * It is useful to have a greater control on the seed.
 * <P>
 * @author <a href="mailto:Olivier.Sigaud@lip6.fr"> Olivier Sigaud</a> and <a href="mailto:gerpy@free.fr"> Pierre Grard</a>.
 */

public final class StaticRandom
{
    // private static int cpt=0;
    private static Random random = new Random();

    public static final void setSeed(long seed)
    {
	random = new Random(seed);
    }
    public static final float nextFloat()
    {
	float nextRandom = random.nextFloat();
	//Exception e = new Exception();
	//e.printStackTrace();
	//System.out.println("Appel de nextFloat() : " + cpt + ":" + nextRandom);
	// if (cpt==2) System.exit(-1);
	//    cpt++;
	if (nextRandom==1.0)
	    return nextFloat();
	else
	    return nextRandom;
    }
    public static final double nextDouble()
    {
	//Exception e = new Exception();
	//e.printStackTrace();
	//System.out.println("appel de nextDouble");
	return random.nextDouble();
    }
    public static final int nextInt(int max)
    {
	return random.nextInt(max);
    }
}

